/**
 * .jsx for Adobe Illustrator. Marat Shagiev: marat_js@bk.ru. 05.2014
 * скрипт для добавления в текст символов конъюнкции, дизъюнкции и т.д.
 * для оформления задач из курса алгебры логики
 */

var insertSymbol = (function () {

  var doc = activeDocument;
  var sel = selection;
  var resultStr = '';
  /*Объект с юникодными шрифтами*/
  var uFonts = function () {
    var o = {
      fontList: ''
    };
    var fontArr = ['Arial', 'Cambria', 'CambriaMath', 'Calibri', 'CourierNewPSMT', 'lucidaSansUnicode', 'TimesNewRomanPSMT'];
    for (var i = 0; i < fontArr.length; i++) {
      try {
        o[fontArr[i]] = textFonts.getByName(fontArr[i]);
      } catch (e) {
      }
    }
    for (var key in o) {
      o.fontList += o[key] + '\n';
    }
    o.toArr = function () {
      var arr = [];
      for (var key in this) {
        if (key == 'fontList' || key == 'toArr') continue;
        arr.push(key);
      }
      return arr;
    }
    return o;
  }();

  /*interface*/
  var face = function () {

    /*сокращения для элементов окна*/
    var ch = 'checkbox', stat = 'statictext', bt = 'button', gr = 'group', pan = 'panel', lb = 'listbox', item = 'item',
      ls = 'dropdownlist';

    var symb = {
      ident: '↔', ident2: '≡', mult: '˄', mult2: '·', sum: '˅', implic: '→', invert: '¬'
    }

    var face = new Window('dialog', 'Вставить символ');

    /*checkboxes*/
    face.chPan = face.add(pan);
    face.chPan.orientation = 'row';
    for (var key in symb) {
      face.chPan[key] = face.chPan.add(ch, undefined, symb[key]);
    }

    /*dropdownlist*/
    var arra = uFonts.toArr();
    arra.unshift('default');
    face.chPan.fList = face.chPan.add(ls, undefined, arra);
    face.chPan.fList.selection = arra[0];
    face.chPan.fList.text = 'Шрифт знака: '

    /*buttons*/
    face.btPan = face.add(gr);
    face.btPan.orientation = 'row';

    face.btPan.ok = face.btPan.add(bt, undefined, 'Да');
    face.btPan.cancel = face.btPan.add(bt, undefined, 'Нет');

    /*event hendlers*/
    face.btPan.cancel.onClick = function () {
      face.close();
    }
    face.btPan.ok.onClick = function () {
      face.close();
      for (var key in symb) {
        if (face.chPan[key].value == true) {
          resultStr += symb[key];
        }
      }

      /*вставка результирующей строки символов*/
      sel.contents = resultStr;
      sel.select(true);
      sel.deSelect();
      sel.characterAttributes.textFont = uFonts[face.chPan.fList.selection.text];

    }

    face.location = [100, 150];
    face.show();
    return face;
  }();

})();

